askmeVlaskina/urls.py
from django.contrib import admin
from django.urls import path
from app import views 
from askmeVlaskina import settings 

urlpatterns = [
    path('admin/', admin.site.urls),
    path('ask/', views.ask),
    path('login/', views.login, name="login"),
    path('questions/<int:pk>/', views.question, name="question"),
    path('tag/<int:pk>/', views.questions_tags, name="tag"),
    path('settings/', views.settings, name="settings"),
    path('signup/', views.signup, name="signup"),
    path('hot/', views.hot, name="hot"),
    path('', views.index, name="main-page"),
]

app/models.py
from django.db import models
from django.contrib.auth.models import User

class QuestionManager(models.Manager): 
    def best_question(self, output_count):
        return self.order_by('-questionlikes__count_likes')[0: output_count]

    def new_question(self, output_count):
        return self.order_by("-date_publication")[0: output_count].select_related()

    def get_one_question(self, pk):
        return Question.objects.get(pk=pk)   

class TagManager(models.Manager): 
    def get_one_tag(self, pk):
        return Tag.objects.get(pk=pk)  

    def get_questions_by_tag(self, tag):
        return tag.question_set.all()             

class Tag(models.Model):
    title = models.CharField(max_length=255, unique=True)
    objects = TagManager()

    def __str__(self): 
        return self.title

    class Meta:
        verbose_name = 'Тег'
        verbose_name_plural = 'Теги'

class Profile(models.Model):
    nick_name = models.CharField(max_length=255)
    email = models.EmailField(unique=True)
    avatar = models.ImageField(upload_to='./media/images', blank=True)
    user = models.OneToOneField(User, on_delete=models.CASCADE)

    def __str__(self):
        return self.nick_name

    class Meta:
        verbose_name = 'Аккаунт'
        verbose_name_plural = 'Аккаунты'    

class Question(models.Model):
    title = models.CharField(max_length=255)
    text = models.TextField()
    date_publication = models.DateTimeField(auto_now_add=True)
    author = models.ForeignKey(Profile, on_delete=models.CASCADE)
    tags = models.ManyToManyField(Tag)

    objects = QuestionManager()

    def __str__(self): 
        return self.title

    class Meta:
        verbose_name = 'Вопрос'
        verbose_name_plural = 'Вопросы'    

class Answer(models.Model):
    text = models.TextField()  
    correct = models.BooleanField()
    question = models.ForeignKey(Question, on_delete=models.CASCADE)
    author = models.ForeignKey(Profile, on_delete=models.CASCADE)

    def __str__(self): 
        return self.text

    class Meta:
        verbose_name = 'Ответ'
        verbose_name_plural = 'Ответы'

class QuestionLikes(models.Model):
  user = models.ForeignKey(Profile, on_delete=models.CASCADE, null=True)
  question = models.ForeignKey(Question, on_delete=models.CASCADE, null=True)
  count_likes = models.IntegerField(default=0)

  def __str__(self):
    return self.user

  class Meta:
    verbose_name = 'Лайки вопроса'
    verbose_name_plural = 'Лайки вопроса'


class AnswerLikes(models.Model):
  user = models.ForeignKey('Profile', on_delete=models.CASCADE, null=True)
  answer = models.ForeignKey('Answer', on_delete=models.CASCADE)
  count_likes = models.IntegerField(default=0)

  def __str__(self):
    return self.user

  class Meta:
    verbose_name = 'Лайки ответа'
    verbose_name_plural = 'Лайки ответа'

app/views.py
from django.shortcuts import render
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger
from app.models import Question, Answer, Tag, Profile

MAX_COUNT_POST_ON_PAGE = 3
MAX_COUNT_ANSWER_ON_PAGE = 5
SIZE_OF_TOP_QUESTION = 15
DEFAULT_COUNT_POST_ON_PAGE = 10
COUNT_NEW_QUESTIONS_TO_OUTPUT = 15

def index(request):
    new_questions = Question.objects.new_question(Question.objects.count())
    page, posts = paginate(new_questions, request, MAX_COUNT_POST_ON_PAGE)
    return render(request,  
	          'index.html',  
		  {'page': page,  
		   'posts': posts}) 

def ask(request): 
    return render(request, 'ask.html', {})

def login(request): 
    return render(request, 'login.html', {})

def question(request, pk): 
    question = Question.objects.get_one_question(pk)
    answers = question.answer_set.all()
    page, posts = paginate(answers, request, MAX_COUNT_ANSWER_ON_PAGE)
    return render(request, 
                 'question.html', 
                 {'question': question,
                 'page': page,
                 'posts': posts})

def questions_tags(request, pk): 

    tag = Tag.objects.get_one_tag(pk)
    questions = Tag.objects.get_questions_by_tag(tag)
    page, posts = paginate(questions, request, 3) 
    return render(request,  
	          'questions-tags.html',  
		      {'tag': tag,
              'page': page,  
		      'posts': posts})

def settings(request): 
    return render(request, 'settings.html', {})

def signup(request): 
    return render(request, 'signup.html', {})

def hot(request): 
    hot_questions = Question.objects.best_question(Question.objects.count())
    page, posts = paginate(hot_questions, request, MAX_COUNT_POST_ON_PAGE)
    return render(request,  
	          'hot.html',  
		  {'page': page,  
		   'posts': posts})  

def paginate(objects_list, request, per_page=DEFAULT_COUNT_POST_ON_PAGE):
    paginator = Paginator(objects_list, per_page) 
    page = request.GET.get('page') 
    try:  
        posts = paginator.page(page)  
    except PageNotAnInteger:  
        posts = paginator.page(1)  
    except EmptyPage:  
        posts = paginator.page(paginator.num_pages)  
    return page, posts

templates/ask.html
{% extends "include/base.html" %}
{% load static %}

{% block name_page %}
  <title>Ask questions</title>
{% endblock name_page %}

{% block authority %}
  {% include "include/register.html" %}
{% endblock authority %}   

{% block content %}
        <div class="col-8 answer-questions">
          <div class="row topic-name">
            <span class="department">New questions </span>
          </div>
          <form name="question">
            <div class="mb-3 row">
                  <label for="FormControlInputTitle" class="col-sm-2 col-form-label">Title</label>
                  <div class="col-sm-6">
                      <input type="text" class="form-control is-invalid" id="validationTitle" aria-describedby="validationFeedbackTitle" placeholder="How to build moon park?" maxlength="128" required>
                      <div id="validationFeedbackLoginSignUp" class="invalid-feedback">
                        Please enter a title.
                      </div>
                  </div>
              </div>
              <form class="was-validated">
                <div class="mb-3 row">
                    <label for="FormControlInputText" class="col-sm-2 col-form-label">Text</label>
                    <div class="col-sm-6">
                      <textarea class="form-control" id="FormControlTextarea" placeholder="Really, how? Have no idea about it." rows="12" maxlength="1000" required></textarea>
                      <div id="validationFeedbackTextQuestion" class="invalid-feedback">
                        Please enter a message.
                      </div>
                    </div>
                </div>
              </form>
              <div class="mb-3 row">
                  <label for="FormControlInputTags" class="col-sm-2 col-form-label">Tags</label>
                  <div class="col-sm-6">
                    <input type="text" class="form-control form-control-100" id="FormControlInputTags" placeholder="moon, park, puzzle" maxlength="50">
                </div>
              </div>
              <div class="row ask-question">
                  <button type="submit" class="btn btn-ask">ASK!</button>
              </div> 
          </form>
        </div> 
{% endblock content %}   

templates/hot.html
{% extends "include/base.html" %}
{% load static %}

{% block name_page %}
  <title>Hot questions</title>
{% endblock name_page %}

{% block authority %}
  {% include "include/register.html" %}
{% endblock authority %}   

{% block content %}
  <div class="col-8 new-questions">
      <div class="row topic-name">
          <span class="department">Hot questions <a href="{% url 'main-page' %}">   New Questions</a></span>
      </div>
      {% for post in posts %}
        {% include "include/one-question.html" %}
      {% endfor %}  
      {% include "include/pagination.html" with page=posts %} 
  </div>
{% endblock content %}    

templates/include/answer.html
{% load static %}
<div class="row answer">
    <div class="col-3 avatar">
        {% if post.author.avatar %}
            <img src="{{ post.author.avatar.url }}">
        {% else %}
            <img src="{% static "img/cat.jpg" %}">
        {% endif %}
        <div class="like"> 
            {% include "include/like.html" %}
            {% if post.answerlikes_set.all.first.count_likes == NULL %}
                <output class="count-likes">{{ 0 }}</output>
            {% else %}    
                <output class="count-likes">{{ post.answerlikes_set.all.first.count_likes }}</output>
            {% endif %}    
        </div>
    </div>
    <div class="col-9 answer-itself">
        <div>
            {{ post.text }}
        </div>
        <div class="form-check form-check-inline">
            <input class="form-check-input" type="checkbox" id="inlineCheckboxCorrect" value="optionCorrect">
            <label class="form-check-label" for="inlineCheckboxCorrect">Correct!</label>
        </div>
    </div>
</div>

templates/include/avatar.html
{% load static %}
<div class="col-3 avatar">
    <img src="{% static "img/cat.jpg" %}">
    {% include "include/like.html" %}
</div>

templates/include/base.html
{% load static %}
<!doctype html>
<html lang="en" class="h-100">
  <head>
    <meta charset="utf-8">
    {% block name_page %}
    {% endblock name_page %}
    <link href="{% static "css/bootstrap.min.css" %}" rel="stylesheet">
    <style>
      .bd-placeholder-img {
        font-size: 1.125rem;
        text-anchor: middle;
        -webkit-user-select: none;
        -moz-user-select: none;
        user-select: none;
      }

      @media (min-width: 768px) {
        .bd-placeholder-img-lg {
          font-size: 3.5rem;
        }
      }
    </style>
    <link href="{% static "css/my.css" %}" rel="stylesheet">
  </head>

<body class="d-flex flex-column h-100">   
<header>
  <nav>
  <ul class="top-menu">
		<li><h1 class="logo"><a href="{% url 'main-page' %}">AskVlaskina</a></h1></li>
		<li class="nav-item">
      <form class="d-flex">
        <input class="form-control me-2" type="search" placeholder="Search" aria-label="Search">
        <button class="btn btn-outline-success" type="submit">Ask!</button>
      </form>
    </li>
      {% block authority %}
      {% endblock authority %}
	</ul>
  </nav>
</header>

<!-- Begin page content -->
<main class="flex-shrink-0">
  <div class="container"> 
      <div class="row">
            {% block content %}
            {% endblock content %}
        <div class="col-4 some-date" >
                <h2 class="popular">Popular tags</h2>
                <div class="row tags">
                  <p><span class="basic_tags">perl </span> <span class="not_popular_tags">Python </span> <span class="basic_tags">TechnoPark</span></p>
                  <p><span class="not_popular_tags">MySQL </span> <span class="popular_tags">django </span> </p> 
                  <p><span class="basic_tags">Mail.Ru </span> <span class="basic_tags">Voloshin </span>  <span class="orange_tags">FireFox </span></p>
                </div>
                <div class="members">
            <h2>Best Members</h2>
            <a href="#">Mr. Freeman</a> <br/>
            <a href="#">Dr. House</a><br/>
            <a href="#">Benedr</a><br/>
            <a href="#">Queen Victoria</a><br/>
            <a href="#">V. Pupkin</a><br/>
                </div>
      </div>
  </div>
</div> 
</main>
<footer>
  Copyright Дарья Власкина
</footer>
<script src="{% static "js/bootstrap.bundle.min.js" %}" integrity="sha384-b5kHyXgcpbZJO/tY9Ul7kGkf1S0CWuKcCD38l8YkeH8z8QjE0GmW1gYU5S9FOnJ0"></script>
</body>
</html>

templates/include/like.html
{% load static %}

<button type="button" class="btn btn-success">
    <img src="{% static "img/like.svg" %}">
</button>
<button type="button" class="btn btn-danger">
    <img src="{% static "img/dislike.svg" %}">
</button>
  

templates/include/one-question.html
{% load static %}
<div class="row question">
    <div class="col-3 avatar">
        {% if post.author.avatar %}
            <img src="{{ post.author.avatar.url }}">
        {% else %}
            <img src="{% static "img/cat.jpg" %}">
        {% endif %}
        <div class="like"> 
            {% include "include/like.html" %}
            {% if post.questionlikes_set.all.first.count_likes == NULL %}
                <output class="count-likes">{{ 0 }}</output>
            {% else %}    
                <output class="count-likes">{{ post.questionlikes_set.all.first.count_likes }}</output>
            {% endif %}   
        </div>
    </div>
    <div class="col-9 question-itself">
        <a href="{% url "question" pk=post.id %}"><h2>{{ post.title }}</h2></a> 
        <div>
            {{ post.text }}
        </div>
        <div class="row references">
            <div class="col-4">
                <a href="{% url "question" pk=post.id %}">answer({{ post.answer_set.all.count }}) </a>
            </div>
        </div>
        <div class="col-8">
            Tags:
            {% for tag in post.tags.all %}
                <a href="{% url "tag" pk=tag.id %}">{{ tag.title }}</a> 
            {% endfor %}
        </div>
    </div>
</div>

templates/include/pagination.html
{% load static %}
<nav aria-label="Page navigation question">
    <div class="pagination">  
      <span class="step-links">  
      {% if page.has_previous %}  
          <a href="?page={{ page.previous_page_number }}"><img src="{% static "img/previous.svg" alt="" %}"></a>  
      {% endif %}  
        <span class="current">  
      Page {{ page.number }} of {{ page.paginator.num_pages }} 
        </span>  
      {% if page.has_next %}  
            <a href="?page={{ page.next_page_number }}"><img src="{% static "img/next.svg" alt="" %}"></a>  
      {% endif %}  
      </span>  
    </div>
</nav>

templates/include/question-with-answer.html
{% load static %}

<div class="row main-question">
    <div class="col-3 avatar">
        {% if post.author.avatar %}
            <img src="{{ question.author.avatar.url }}">
        {% else %}
            <img src="{% static "img/cat.jpg" %}">
        {% endif %}
        <div class="like"> 
            {% include "include/like.html" %}
            {% if post.questionlikes_set.all.first.count_likes == NULL %}
                <output class="count-likes">{{ 0 }}</output>
            {% else %}    
                <output class="count-likes">{{ post.questionlikes_set.all.first.count_likes }}</output>
            {% endif %}  
        </div>
    </div>
    <div class="col-9 question-itself">
        </a><h2>{{ question.title }}</h2>
        <div>
            {{ question.text }}
        </div>
        <div class="row references">
            <div class="col-8">
                {% for tag in question.tags.all %}
                    <a href="{% url "tag" pk=tag.id %}">{{ tag.title }}</a> 
                {% endfor %}
            </div>
        </div>
    </div>
</div>

templates/include/register.html
{% load static %}
<li class="authority">
    <div class="row name">
        Dr. Pepper
      </div>
      <div class="row navigation">
        <div class="col">
          <a href="{% url 'settings' %}">settings</a>
        </div>
        <div class="col">
          <a href="{% url 'login' %}">log out</a>
        </div>
      </div>  
</li>
<li class="my-avatar"><img src="{% static "img/cat.jpg" %}"></li>

templates/include/unregister.html
<li class="authority">
    <div class="row navigation">
      <div class="col">
        <a href="{% url 'login' %}">log in</a>
      </div>
      <div class="col">
        <a href="{% url 'signup' %}">register</a>
      </div>
    </div>  
</li>

templates/index.html
{% extends "include/base.html" %}
{% load static %}

{% block name_page %}
  <title>Listing questions</title>
{% endblock name_page %}

{% block authority %}
  {% include "include/register.html" %}
{% endblock authority %}   

{% block content %}
  <div class="col-8 new-questions">
      <div class="row topic-name">
          <span class="department">New questions <a href="{% url 'hot' %}">   Hot Questions</a></span>
      </div>
      {% for post in posts %}
        {% include "include/one-question.html" %}
      {% endfor %}  
      {% include "include/pagination.html" with page=posts %} 
  </div>
{% endblock content %}    

templates/login.html
{% extends "include/base.html" %}
{% load static %}

{% block name_page %}
  <title>Authorization</title>
{% endblock name_page %}

{% block authority %}
  {% include "include/unregister.html" %}
{% endblock authority %}   

{% block content %}
  <div class="col-8 log authorization">
    <div class="row topic-name">
        <span class="department">Log In</span>
    </div>
    <form name="login">
      <div class="mb-3 row">
        <label for="validationInputLogin" class="col-sm-2 col-form-label">Login</label>
        <div class="col-sm-6">
            <input type="text" class="form-control is-invalid" id="validationInputLogin" aria-describedby="validationFeedbackLogin" placeholder="Enter your login here" maxlength="20" required>
            <div id="validationFeedbackLogin" class="invalid-feedback">
                Sorry, wrong login!
            </div>
        </div>
      </div>
      <div class="mb-3 row">
        <label for="validationInputPassword" class="col-sm-2 col-form-label">Password</label>
        <div class="col-sm-6">
            <input type="password" class="form-control is-invalid" id="validationInputPassword" aria-describedby="validationFeedbackPassword" placeholder="Enter your password here" maxlength="30" required>
            <div id="validationFeedbackPassword" class="invalid-feedback">
                Sorry, wrong password!
            </div>
        </div>
      </div>
     <div class="row log-in">
        <button type="submit" class="btn btn-login">Log in!</button>
     </div> 
    </form>
    <a class="new-account" href="{% url 'signup' %}">create new account</a>
  </div> 
{% endblock content %}   

templates/question.html
{% extends "include/base.html" %}
{% load static %}

{% block name_page %}
  <title>One question</title>
{% endblock name_page %}

{% block authority %}
  {% include "include/unregister.html" %}
{% endblock authority %}   

{% block content %}
    <div class="col-8 page-question">
          {% include "include/question-with-answer.html" %}
          <hr>
          {% for post in posts %}
            {% include "include/answer.html" %} 
          {% endfor %}  
          {% include "include/pagination.html" with page=posts %} 
        <hr>
        <div class="row new-answer">
            <input class="form-control" type="text" placeholder="Enter your answer here." aria-label=" answer input">
            <button type="submit" class="btn btn-answer">Answer</button>
        </div>
    </div>
{% endblock content %} 

templates/questions-tags.html
{% extends "include/base.html" %}
{% load static %}

{% block name_page %}
  <title>Listing questions by tag</title>
{% endblock name_page %}

{% block authority %}
  {% include "include/unregister.html" %}
{% endblock authority %}   

{% block content %}
  <div class="col-8 new-questions">
    <div class="row topic-name">
      <span class="department">Tag: {{ tag.title }} </span>
    </div>
    {% for post in posts %}
        {% include "include/one-question.html" %}
    {% endfor %}  
    {% include "include/pagination.html" with page=posts %} 
  </div>
{% endblock content %}   

templates/settings.html
{% extends "include/base.html" %}
{% load static %}

{% block name_page %}
  <title>Settings</title>
{% endblock name_page %}

{% block authority %}
  {% include "include/register.html" %}
{% endblock authority %}   

{% block content %}
  <div class="col-8 settings">
    <div class="row topic-name">
      <span class="department">Settings: Dr. Pepper</span>
    </div>
    <div class="mb-3 row">
          <label for="formControlInputLogin" class="col-sm-2 col-form-label">Login</label>
          <div class="col-sm-6">
              <input type="text" class="form-control form-control-100" id="formControlInputLogin" placeholder="dr_pepper" maxlength="20">
          </div>
      </div>
      <div class="mb-3 row">
          <label for="formControlInputEmail" class="col-sm-2 col-form-label">Email</label>
          <div class="col-sm-6">
              <input type="email" class="form-control form-control-100" id="formControlInputEmail" placeholder="dr.pepper@mail.ru" maxlength="50">
          </div>
      </div>
      <div class="mb-3 row">
          <label for="formControlInputNikName" class="col-sm-2 col-form-label">NikName</label>
          <div class="col-sm-6">
              <input type="text" class="form-control form-control-100" id="formControlInputNikName" placeholder="Dr.Pepper" maxlength="50">
          </div>
      </div>
      <div class="mb-3">
          <label for="formChangeAvatar" class="form-label">Upload avatar</label>
          <img src="{% static "img/cat.jpg" %}">
          <input class="form-control" type="file" id="formChangeAvatar" accept="image/*">
      </div>
      <div class="row save">
          <button type="submit" class="btn btn-save">Save</button>
      </div> 
  </div>
{% endblock content %}   

templates/signup.html
{% extends "include/base.html" %}
{% load static %}

{% block name_page %}
  <title>Sign up</title>
{% endblock name_page %}

{% block authority %}
  {% include "include/unregister.html" %}
{% endblock authority %}   

{% block content %}
  <div class="col-8 log registration">
    <div class="row topic-name">
        <span class="department">Registration</span>
    </div>
    <form name="sigin">
        <div class="mb-3 row">
            <label for="validationEmailSignUp" class="col-sm-2 col-form-label">Email</label>
            <div class="col-sm-6">
                <input type="text" class="form-control is-invalid" id="validationEmailSignUp" aria-describedby="validationFeedbackEmailSignUp" placeholder="dr_pepper" maxlength="20" required>
                <div id="validationFeedbackEmailSignUp" class="invalid-feedback">
                    Sorry, this login already registred!
                </div>
            </div>
        </div>
        <div class="mb-3 row">
            <label for="validationNickNameSignUp" class="col-sm-2 col-form-label">Nickname</label>
            <div class="col-sm-6">
                <input type="email" class="form-control is-invalid" id="validationNickNameSignUp" aria-describedby="validationFeedbackNickNameSignUp" placeholder="dr.pepper@mail.ru" maxlength="50" required>
                <div id="validationFeedbackNickNameSignUp" class="invalid-feedback">
                    Sorry, this email address already registred!
                </div>
            </div>
        </div>
        <div class="mb-3 row">
            <label for="validationLoginSignUp" class="col-sm-2 col-form-label">Login</label>
            <div class="col-sm-6">
                <input type="text" class="form-control is-invalid" id="validationLoginSignUp" aria-describedby="validationFeedbackLoginSignUp" placeholder="Dr.Pepper" maxlength="20" required>
                <div id="validationFeedbackLoginSignUp" class="invalid-feedback">
                    Sorry, this nickname already registred!
                </div>
            </div>
        </div>
        <div class="mb-3 row">
            <label for="validationPasswordSignUp" class="col-sm-2 col-form-label">Password</label>
            <div class="col-sm-6">
                <input type="password" class="form-control is-invalid" id="validationPasswordSignUp" aria-describedby="validationFeedbackPasswordSignUp" maxlength="30" required>
                <div id="validationFeedbackPasswordSignUp" class="invalid-feedback">
                    Sorry, incorrect password!
                </div>
            </div>
        </div>
        <div class="mb-3 row">
            <label for="validationRepeatPassword" class="col-sm-2 col-form-label">Repeat password</label>
            <div class="col-sm-6">
                <input type="password" class="form-control is-invalid" id="validationRepeatPassword" aria-describedby="validationFeedbackRepeatPassword" maxlength="30" required>
                <div id="validationFeedbackRepeatPassword" class="invalid-feedback">
                    Sorry, passwords does not match!
                </div>
            </div>
        </div>
        <div class="mb-3 row">
            <label for="formUploadAvatar" class="col-sm-2 col-form-label">Upload avatar</label>
            <div class="col-sm-6">
                <input type="file" class="form-control form-control-100" id="formUploadAvatar" accept="image/*">
            </div>    
        </div>
        <div class="row register">
            <button type="submit" class="btn btn-register">Register!</button>
        </div> 
   </form>
  </div> 
{% endblock content %}   